/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.unisef.managesales.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import it.unisef.managesales.model.Worker;
import it.unisef.managesales.model.WorkerModel;
import it.unisef.managesales.model.WorkerSoap;

import java.io.Serializable;

import java.sql.Types;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the Worker service. Represents a row in the &quot;MS_Worker&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link it.unisef.managesales.model.WorkerModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link WorkerImpl}.
 * </p>
 *
 * @author Giulio Piemontese
 * @see WorkerImpl
 * @see it.unisef.managesales.model.Worker
 * @see it.unisef.managesales.model.WorkerModel
 * @generated
 */
@JSON(strict = true)
public class WorkerModelImpl extends BaseModelImpl<Worker>
	implements WorkerModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a worker model instance should use the {@link it.unisef.managesales.model.Worker} interface instead.
	 */
	public static final String TABLE_NAME = "MS_Worker";
	public static final Object[][] TABLE_COLUMNS = {
			{ "workerId", Types.BIGINT },
			{ "companyId", Types.BIGINT },
			{ "userId", Types.BIGINT },
			{ "userName", Types.VARCHAR },
			{ "createDate", Types.TIMESTAMP },
			{ "modifiedDate", Types.TIMESTAMP },
			{ "groupId", Types.BIGINT },
			{ "firstName", Types.VARCHAR },
			{ "lastName", Types.VARCHAR },
			{ "firmId", Types.BIGINT },
			{ "employmentDate", Types.TIMESTAMP },
			{ "code_", Types.VARCHAR }
		};
	public static final String TABLE_SQL_CREATE = "create table MS_Worker (workerId LONG not null primary key,companyId LONG,userId LONG,userName VARCHAR(75) null,createDate DATE null,modifiedDate DATE null,groupId LONG,firstName VARCHAR(75) null,lastName VARCHAR(75) null,firmId LONG,employmentDate DATE null,code_ VARCHAR(75) null)";
	public static final String TABLE_SQL_DROP = "drop table MS_Worker";
	public static final String ORDER_BY_JPQL = " ORDER BY worker.code ASC";
	public static final String ORDER_BY_SQL = " ORDER BY MS_Worker.code_ ASC";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.it.unisef.managesales.model.Worker"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.it.unisef.managesales.model.Worker"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.column.bitmask.enabled.it.unisef.managesales.model.Worker"),
			true);
	public static long COMPANYID_COLUMN_BITMASK = 1L;
	public static long FIRMID_COLUMN_BITMASK = 2L;
	public static long GROUPID_COLUMN_BITMASK = 4L;

	/**
	 * Converts the soap model instance into a normal model instance.
	 *
	 * @param soapModel the soap model instance to convert
	 * @return the normal model instance
	 */
	public static Worker toModel(WorkerSoap soapModel) {
		if (soapModel == null) {
			return null;
		}

		Worker model = new WorkerImpl();

		model.setWorkerId(soapModel.getWorkerId());
		model.setCompanyId(soapModel.getCompanyId());
		model.setUserId(soapModel.getUserId());
		model.setUserName(soapModel.getUserName());
		model.setCreateDate(soapModel.getCreateDate());
		model.setModifiedDate(soapModel.getModifiedDate());
		model.setGroupId(soapModel.getGroupId());
		model.setFirstName(soapModel.getFirstName());
		model.setLastName(soapModel.getLastName());
		model.setFirmId(soapModel.getFirmId());
		model.setEmploymentDate(soapModel.getEmploymentDate());
		model.setCode(soapModel.getCode());

		return model;
	}

	/**
	 * Converts the soap model instances into normal model instances.
	 *
	 * @param soapModels the soap model instances to convert
	 * @return the normal model instances
	 */
	public static List<Worker> toModels(WorkerSoap[] soapModels) {
		if (soapModels == null) {
			return null;
		}

		List<Worker> models = new ArrayList<Worker>(soapModels.length);

		for (WorkerSoap soapModel : soapModels) {
			models.add(toModel(soapModel));
		}

		return models;
	}

	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.it.unisef.managesales.model.Worker"));

	public WorkerModelImpl() {
	}

	public long getPrimaryKey() {
		return _workerId;
	}

	public void setPrimaryKey(long primaryKey) {
		setWorkerId(primaryKey);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_workerId);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	public Class<?> getModelClass() {
		return Worker.class;
	}

	public String getModelClassName() {
		return Worker.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("workerId", getWorkerId());
		attributes.put("companyId", getCompanyId());
		attributes.put("userId", getUserId());
		attributes.put("userName", getUserName());
		attributes.put("createDate", getCreateDate());
		attributes.put("modifiedDate", getModifiedDate());
		attributes.put("groupId", getGroupId());
		attributes.put("firstName", getFirstName());
		attributes.put("lastName", getLastName());
		attributes.put("firmId", getFirmId());
		attributes.put("employmentDate", getEmploymentDate());
		attributes.put("code", getCode());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long workerId = (Long)attributes.get("workerId");

		if (workerId != null) {
			setWorkerId(workerId);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}

		String userName = (String)attributes.get("userName");

		if (userName != null) {
			setUserName(userName);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date modifiedDate = (Date)attributes.get("modifiedDate");

		if (modifiedDate != null) {
			setModifiedDate(modifiedDate);
		}

		Long groupId = (Long)attributes.get("groupId");

		if (groupId != null) {
			setGroupId(groupId);
		}

		String firstName = (String)attributes.get("firstName");

		if (firstName != null) {
			setFirstName(firstName);
		}

		String lastName = (String)attributes.get("lastName");

		if (lastName != null) {
			setLastName(lastName);
		}

		Long firmId = (Long)attributes.get("firmId");

		if (firmId != null) {
			setFirmId(firmId);
		}

		Date employmentDate = (Date)attributes.get("employmentDate");

		if (employmentDate != null) {
			setEmploymentDate(employmentDate);
		}

		String code = (String)attributes.get("code");

		if (code != null) {
			setCode(code);
		}
	}

	@JSON
	public long getWorkerId() {
		return _workerId;
	}

	public void setWorkerId(long workerId) {
		_workerId = workerId;
	}

	@JSON
	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_columnBitmask |= COMPANYID_COLUMN_BITMASK;

		if (!_setOriginalCompanyId) {
			_setOriginalCompanyId = true;

			_originalCompanyId = _companyId;
		}

		_companyId = companyId;
	}

	public long getOriginalCompanyId() {
		return _originalCompanyId;
	}

	@JSON
	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	@JSON
	public String getUserName() {
		if (_userName == null) {
			return StringPool.BLANK;
		}
		else {
			return _userName;
		}
	}

	public void setUserName(String userName) {
		_userName = userName;
	}

	@JSON
	public Date getCreateDate() {
		return _createDate;
	}

	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	@JSON
	public Date getModifiedDate() {
		return _modifiedDate;
	}

	public void setModifiedDate(Date modifiedDate) {
		_modifiedDate = modifiedDate;
	}

	@JSON
	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_columnBitmask |= GROUPID_COLUMN_BITMASK;

		if (!_setOriginalGroupId) {
			_setOriginalGroupId = true;

			_originalGroupId = _groupId;
		}

		_groupId = groupId;
	}

	public long getOriginalGroupId() {
		return _originalGroupId;
	}

	@JSON
	public String getFirstName() {
		if (_firstName == null) {
			return StringPool.BLANK;
		}
		else {
			return _firstName;
		}
	}

	public void setFirstName(String firstName) {
		_firstName = firstName;
	}

	@JSON
	public String getLastName() {
		if (_lastName == null) {
			return StringPool.BLANK;
		}
		else {
			return _lastName;
		}
	}

	public void setLastName(String lastName) {
		_lastName = lastName;
	}

	@JSON
	public long getFirmId() {
		return _firmId;
	}

	public void setFirmId(long firmId) {
		_columnBitmask |= FIRMID_COLUMN_BITMASK;

		if (!_setOriginalFirmId) {
			_setOriginalFirmId = true;

			_originalFirmId = _firmId;
		}

		_firmId = firmId;
	}

	public long getOriginalFirmId() {
		return _originalFirmId;
	}

	@JSON
	public Date getEmploymentDate() {
		return _employmentDate;
	}

	public void setEmploymentDate(Date employmentDate) {
		_employmentDate = employmentDate;
	}

	@JSON
	public String getCode() {
		if (_code == null) {
			return StringPool.BLANK;
		}
		else {
			return _code;
		}
	}

	public void setCode(String code) {
		_columnBitmask = -1L;

		_code = code;
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
			Worker.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public Worker toEscapedModel() {
		if (_escapedModelProxy == null) {
			_escapedModelProxy = (Worker)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelProxyInterfaces,
					new AutoEscapeBeanHandler(this));
		}

		return _escapedModelProxy;
	}

	@Override
	public Object clone() {
		WorkerImpl workerImpl = new WorkerImpl();

		workerImpl.setWorkerId(getWorkerId());
		workerImpl.setCompanyId(getCompanyId());
		workerImpl.setUserId(getUserId());
		workerImpl.setUserName(getUserName());
		workerImpl.setCreateDate(getCreateDate());
		workerImpl.setModifiedDate(getModifiedDate());
		workerImpl.setGroupId(getGroupId());
		workerImpl.setFirstName(getFirstName());
		workerImpl.setLastName(getLastName());
		workerImpl.setFirmId(getFirmId());
		workerImpl.setEmploymentDate(getEmploymentDate());
		workerImpl.setCode(getCode());

		workerImpl.resetOriginalValues();

		return workerImpl;
	}

	public int compareTo(Worker worker) {
		int value = 0;

		value = getCode().compareTo(worker.getCode());

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		Worker worker = null;

		try {
			worker = (Worker)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long primaryKey = worker.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public void resetOriginalValues() {
		WorkerModelImpl workerModelImpl = this;

		workerModelImpl._originalCompanyId = workerModelImpl._companyId;

		workerModelImpl._setOriginalCompanyId = false;

		workerModelImpl._originalGroupId = workerModelImpl._groupId;

		workerModelImpl._setOriginalGroupId = false;

		workerModelImpl._originalFirmId = workerModelImpl._firmId;

		workerModelImpl._setOriginalFirmId = false;

		workerModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<Worker> toCacheModel() {
		WorkerCacheModel workerCacheModel = new WorkerCacheModel();

		workerCacheModel.workerId = getWorkerId();

		workerCacheModel.companyId = getCompanyId();

		workerCacheModel.userId = getUserId();

		workerCacheModel.userName = getUserName();

		String userName = workerCacheModel.userName;

		if ((userName != null) && (userName.length() == 0)) {
			workerCacheModel.userName = null;
		}

		Date createDate = getCreateDate();

		if (createDate != null) {
			workerCacheModel.createDate = createDate.getTime();
		}
		else {
			workerCacheModel.createDate = Long.MIN_VALUE;
		}

		Date modifiedDate = getModifiedDate();

		if (modifiedDate != null) {
			workerCacheModel.modifiedDate = modifiedDate.getTime();
		}
		else {
			workerCacheModel.modifiedDate = Long.MIN_VALUE;
		}

		workerCacheModel.groupId = getGroupId();

		workerCacheModel.firstName = getFirstName();

		String firstName = workerCacheModel.firstName;

		if ((firstName != null) && (firstName.length() == 0)) {
			workerCacheModel.firstName = null;
		}

		workerCacheModel.lastName = getLastName();

		String lastName = workerCacheModel.lastName;

		if ((lastName != null) && (lastName.length() == 0)) {
			workerCacheModel.lastName = null;
		}

		workerCacheModel.firmId = getFirmId();

		Date employmentDate = getEmploymentDate();

		if (employmentDate != null) {
			workerCacheModel.employmentDate = employmentDate.getTime();
		}
		else {
			workerCacheModel.employmentDate = Long.MIN_VALUE;
		}

		workerCacheModel.code = getCode();

		String code = workerCacheModel.code;

		if ((code != null) && (code.length() == 0)) {
			workerCacheModel.code = null;
		}

		return workerCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(25);

		sb.append("{workerId=");
		sb.append(getWorkerId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append(", userName=");
		sb.append(getUserName());
		sb.append(", createDate=");
		sb.append(getCreateDate());
		sb.append(", modifiedDate=");
		sb.append(getModifiedDate());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", firstName=");
		sb.append(getFirstName());
		sb.append(", lastName=");
		sb.append(getLastName());
		sb.append(", firmId=");
		sb.append(getFirmId());
		sb.append(", employmentDate=");
		sb.append(getEmploymentDate());
		sb.append(", code=");
		sb.append(getCode());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(40);

		sb.append("<model><model-name>");
		sb.append("it.unisef.managesales.model.Worker");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>workerId</column-name><column-value><![CDATA[");
		sb.append(getWorkerId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userName</column-name><column-value><![CDATA[");
		sb.append(getUserName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>createDate</column-name><column-value><![CDATA[");
		sb.append(getCreateDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
		sb.append(getModifiedDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>firstName</column-name><column-value><![CDATA[");
		sb.append(getFirstName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>lastName</column-name><column-value><![CDATA[");
		sb.append(getLastName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>firmId</column-name><column-value><![CDATA[");
		sb.append(getFirmId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>employmentDate</column-name><column-value><![CDATA[");
		sb.append(getEmploymentDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>code</column-name><column-value><![CDATA[");
		sb.append(getCode());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static ClassLoader _classLoader = Worker.class.getClassLoader();
	private static Class<?>[] _escapedModelProxyInterfaces = new Class[] {
			Worker.class
		};
	private long _workerId;
	private long _companyId;
	private long _originalCompanyId;
	private boolean _setOriginalCompanyId;
	private long _userId;
	private String _userUuid;
	private String _userName;
	private Date _createDate;
	private Date _modifiedDate;
	private long _groupId;
	private long _originalGroupId;
	private boolean _setOriginalGroupId;
	private String _firstName;
	private String _lastName;
	private long _firmId;
	private long _originalFirmId;
	private boolean _setOriginalFirmId;
	private Date _employmentDate;
	private String _code;
	private long _columnBitmask;
	private Worker _escapedModelProxy;
}